﻿/*!
 * eex JavaScript Library v1.0.3
 * http://www.ww-a.de/
 * Copyright 2013, Wolfgang Wolf
 * licensed under the GPL Version 2 licenses.
 * Date: 30.05.2014 in Vorbereitung auf die Version 2.0
 */

var eex=new function() {
	this.ms = {
	noValRes:"kein g&uuml;ltiges Ergebnis!",
	btnSubmit:"L&ouml;sung senden",
	btnRefresh:"Seite neu laden",
	btnContent:"Inhalt",
	questSaveRes:"Du hast %result%% der Aufgaben richtig gel%F6st.",
	questSaveQuest:"\nSoll dieses Ergebnis gespeichert werden?",
	mcMoveFirst:"Erste Frage",
	mcMovePrevious:"Vorherige Frage",
	mcMoveNext:"N&auml;chste Frage",
	mcMoveLast:"Letzte Frage",
	mcQuestIncorrect:"Mindestens eine Antwort ist falsch!",
	mcQuestCorrect:"Diese Antwort ist richtig!",
	cDecimal:","
	}

	var startTime = new Date().getTime();
	//Aufgabendauer ausgeben
	this.elapsedTime = function() {
		return Math.ceil((new Date().getTime() - startTime) / 1000)
	}
	//Flag für gesendet	
	var isSubmited = false;
	this.setSubmited = function() {
		isSubmited = true;
	}
	this.getSubmited = function() {
		return isSubmited; 
	}
	//lokales Ergebnis setzen und ausgeben
	var result = 0;
	this.setResult = function(res){
		if(isNaN(res) || res<0 || res>100) {
			throw res + ": " + this.ms.noValRes; 
		} else {
			result = res;
		}
	};
	this.getResult = function() {
		return result;
	}
	//Array mit Primzahlen bis 100
	this.primeNumber100 = [2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97];
	//Zufallsnummer 
		this.getRandomNumber = function(min, max) {
		if (min > max) return -1;
		if (min === max) return (min);
		return (min + Math.floor(Math.random() * (max - min + 1)))
	}
	//Zufallselement aus Array
	this.getRandomArray = function(arr) {
		var a = (arguments.length > 1) ? arguments : arr;
		return a[Math.floor(Math.random() * a.length)]
	}
	//Rest aus Division
	this.getRest=function(dd,ds) {
		return dd % ds;
	}
	//Zerlegung in Primfaktoren
	this.primeFactorization = function (n) {
		var res = new Array();
		for (var i = 0; i < eex.primeNumber100.length; i++) {
			if (eex.primeNumber100[i] < n) { 
				while (n % eex.primeNumber100[i] === 0) {
					res.push(eex.primeNumber100[i]);
					n = n / eex.primeNumber100[i];
				}
			} else {
				if (eex.primeNumber100[i] === n) res.push(eex.primeNumber100[i]);
			}
		}
		return res;
	}

	this.primeFactorizationPow = function (n) {
		var res = new Array(25);
		for (var j = 0; j < eex.primeNumber100.length; j++) res[j] = 0;
		for (var i = 0; i < eex.primeNumber100.length; i++) {
			if (eex.primeNumber100[i] < n) { 
				while (n % eex.primeNumber100[i] === 0) {
					res[i]++;
					n = n / eex.primeNumber100[i];
				}
			} else {
				if (eex.primeNumber100[i] === n) res[i]++;
			}
		}
		return res;
	}

	this.leastCommonMultiple = function() {
		var kgv = 1;
		var powmax;
		var factors = new Array(arguments.length);
		for (var i = 0; i < arguments.length; i++) {
			factors[i] = eex.primeFactorizationPow(arguments[i]) 
		}
		for (var j = 0; j < factors[0].length; j++) {
			powmax = factors[0][j];
			for(var i = 1; i < factors.length; i++)	{
				if (powmax<factors[i][j]) powmax = factors[i][j];
			}
			kgv = kgv * Math.pow(eex.primeNumber100[j], powmax);
		}
		return kgv;
	}

	//Brüche kürzen
	this.reduceFraction=function(num, denum) {
		var f = new Array(Math.abs(num), Math.abs(denum));
		for (var i = 0; i < eex.primeNumber100.length; i++) {
			if (eex.primeNumber100[i] <= f[0] && eex.primeNumber100[i] <= f[1]) {
				while (f[0] % eex.primeNumber100[i ]=== 0 && f[1] % eex.primeNumber100[i] === 0) {
					f[0] = f[0] / eex.primeNumber100[i];
					f[1] = f[1] / eex.primeNumber100[i];
				}
			} else {
				break;
			}
			if (f[0] === f[1]) {
				f[0] = 1;
				f[1] = 1;
			}
		}
		if (num < 0) f[0] = f[0] * -1;
		if (denum < 0) f[1] = f[1] * -1;
		return f;
	}
	
	//Nachkommastellen abschneiden oder ergänzen
	this.toFixedStr = function(n, digits, decchr) {
		if (!decchr) decchr = this.ms.cDecimal;
		var sig = "";
		if (n < 0) {
			sig = "-";
			n = Math.abs(n);
		}
		var zclear = false;
		if (digits < 0) {
			digits = Math.abs(digits);
			zclear = true;
		}
		var p = Math.pow(10, digits + 2);
		n = Math.round(n * p);
		n = n / p;
		var res = n.toString(10);
		var parts = res.split(".");
		if (digits === 0) {
			if (parts[0] !== "0") parts[0]= sig + parts[0];
			res = parts[0];
		} else {	//digits>0
			if (!parts[1]) parts[1] = "0";
			if (!zclear) {	//hinten erweitern
				while(parts[1].length < digits) {
					parts[1]+="0"; 
				}
				parts[1] = parts[1].substring(0, digits);
			} else {	//hinten abschneiden
				parts[1] = parts[1].substring(0, digits);
				while (parts[1].substring(parts[1].length - 1, parts[1].length)==="0") {
					parts[1] = parts[1].substring(0, parts[1].length - 1);
				}
			}
			if (parts[1].length === 0) {
				if (parts[0] !== "0") parts[0]= sig + parts[0];
				res = parts[0];
			} else {
				if (parseInt(parts[1],10) !== 0 || parts[0] !== "0") parts[0]= sig + parts[0];
				res = parts.join(decchr);
			}
		}
		return res;
	}
	//gesprochene Zahlen
	this.numToWord = function(input) {
		//http://www.duden.de/sprachratgeber/schreibung-von-zahlen-1
		var numbers = ['','ein','zwei','drei','vier','fünf','sechs','sieben','acht','neun','zehn','elf','zwölf','dreizehn','vierzehn','fünfzehn','sechszehn','siebzehn','achtzehn','neunzehn'];
		var numbers10 = ['','zehn','zwanzig','dreißig','vierzig','fünfzig','sechzig','siebzig','achtzig','neunzig'];
		var output = '';
		var fN = function (z) {
			if (z<20) return numbers[z];
			var tens = (z - z % 10) / 10;
			var units = z - (z - z % 10);
			return numbers[units] + ((tens > 0 && units > 0) ? 'und' : '') + numbers10[tens];
		}
		var fN3 = function (z) {
			var hundreds = (z - z % 100) / 100;
			z -= hundreds * 100;
			return (hundreds > 0 ? fN(hundreds) + 'hundert' : '') + (z > 0 ? fN(z) : '')
		}
		if (input<0) output = 'minus ';
		var zahl = Math.floor(Math.abs(input));	
		var million = (zahl - zahl % 1000000) / 1000000;
		zahl -= million * 1000000;
		var tausend = (zahl - zahl % 1000) / 1000;
		zahl -= tausend * 1000;
		if (input===0) return "null";
		if (million == 1) {
			output += "eine Million ";
		} else if (million > 1) {
			output += fN3(million) + ' Millionen ';
		}
		output += (tausend > 0 ? fN3(tausend) + 'tausend' : '') + fN3(zahl);
		return output.substring(output.length-3,output.length) == 'ein' ? output + 's' : output;
	}
	  
	//Zahl mit Eingabe-String vergleichen
	this.compare = function (n, s, digits) { 
		if(typeof(n) === "string") {
			if(n === s) return true;
		}
		if(!digits) digits = 0;
		n = eex.toFixedStr(n, digits,".");
		s = s.replace(/,/g,".");
		var dot = s.lastIndexOf(".");
		if (dot === -1) { //kein Punkt enthalten, gehe also von Ganzzahl aus
			if(isNaN(s)) return false;
			s = String(parseInt(s, 10));
			if (digits > 0) s+="."; //mit Punkt ergänzen
			for (var i = 0; i < digits; i++) s+="0";	//0 hinten ergänzen
		} else {
			var voll = s.substring(0, dot); //wo ist der Punkt?
			voll = voll.replace(/\./g, ""); //Tausendtrennzeichen entfernen
			var dez = (s.substring(dot + 1)).substring(0, digits); //Dezimalstellen
			while(dez.length < digits) dez+="0"; //Dezimalstellen ergänzen
			if(isNaN(voll)) return false;
			if(voll.substring(0,1) === '-') {
				s = String(parseInt(voll, 10));
				if(s.substring(0,1) !== '-' && digits > 0) s = "-" + s;
			} else {
				s = String(parseInt("0" + voll, 10));
			}
			if(digits > 0) s += "."+ dez; //String zusammenbauen
		}
		return n === s;
	}
	//String-Vergleich
	this.compareStr = function (str1,str2) {
		if (str1 === str2) {
			return true;
		} else if (str1.charCode() === str2) {
			return true;
		} else if (str1 === str2.charCode()) {
			return true;
		} else {
			return false;
		}
	}

	/**************
	Multiple choice	
	***************/
	this.mcq = new function() {
		this.currentPage = 0;
		this.released = false;
		this.pages = new Array();
		this.addPage = function(q) {
			q.responses.shuffle();
			var p = this.pages.length;
			q.id = p;
			this.pages[p] = q;
		}
		this.setTrial = function(trial){
			var t = trial.split("8");
			for (var i = 0; i < t.length; i++) this.pages[i].setTrial(t[i]);
		}
		this.click=function(id, value) {
			var p,r,i;
			i = id.indexOf(".");
			p = parseInt(id.substring(0,i),10);
			r = parseInt(id.substring(i + 1),10);
			this.pages[p].responses[r].checked = value;
		}
		this.checkResult = function() {
			var r = 0;
			eex.setSubmited();
			for (var i = 0; i < this.pages.length; i++) {
				if (this.pages[i].checkResult()) r++;
			}
			this.released = true;
			this.moveFirst();
			return Math.round(r * 100 / this.pages.length);
		}
		this.moveFirst = function() {this.currentPage = 0; document.getElementById('exercise').innerHTML = this.toHTML()}
		this.moveNext = function() {this.currentPage+=1; document.getElementById('exercise').innerHTML = this.toHTML()}
		this.movePrevious = function() {this.currentPage-=1 ;document.getElementById('exercise').innerHTML = this.toHTML()}
		this.moveLast = function() {this.currentPage=this.pages.length-1; document.getElementById('exercise').innerHTML = this.toHTML()}
		this.toHTML = function() {
			var out = "<p style='font-weight:bold'>Frage " + (this.currentPage+1) + " von " + this.pages.length + ": ";
			if(this.released) {
				if (this.pages[this.currentPage].checkResult()) out+="<span style='color:green; margin-left:5px'>" + eex.ms.mcQuestCorrect + "</span></p>";
				else out+="<span style='color:red; margin-left:5px'>" + eex.ms.mcQuestIncorrect + "</span></p>";
			} else {
				out+="</p>";
			}
			if (this.pages[this.currentPage]) out+=this.pages[this.currentPage].toHTML();
			out+="<p>";
			if (this.currentPage>0) {
				out+="&bull; <a href='javascript:eex.mcq.moveFirst()'>" + eex.ms.mcMoveFirst + "</a>&nbsp;";
				out+="&bull; <a href='javascript:eex.mcq.movePrevious()'>" + eex.ms.mcMovePrevious + "</a>&nbsp;";
			} else {
				out+="&bull; " + eex.ms.mcMoveFirst + "&nbsp;";
				out+="&bull; " + eex.ms.mcMovePrevious + "&nbsp;";
			}
			if (this.currentPage<this.pages.length-1) {
				out+="&bull; <a href='javascript:eex.mcq.moveNext()'>" + eex.ms.mcMoveNext + "</a>&nbsp;";
				out+="&bull; <a href='javascript:eex.mcq.moveLast()'>" + eex.ms.mcMoveLast + "</a>&nbsp;";
			} else {
				out+="&bull; " + eex.ms.mcMoveNext + "&nbsp;";
				out+="&bull; " + eex.ms.mcMoveLast + "&nbsp;";
			}
			//out+="&bull; <a href='javascript:alert(eex.mcq.pages[eex.mcq.currentPage].checkResult())'>Pr&uuml;fen</a>";
			out+="</p>";
			return out;
		}
		this.Question = function (qs,pos) {
			this.id = 0;
			this.trial;
			this.image = "";
			this.possibillities = pos;
			this.question = qs;
			this.responses = new Array();
			this.addResponse = function(r,a) {
				var i = this.responses.length;
				this.responses[i] = {id:i,response:r,checked:false}
			}
			this.setTrial = function(n) {
				var r = 0;
				n = parseInt(n,8);
				this.trial = new Array(); 
				while(n >= 2) {
					r = n % 2;
					this.trial.unshift((r === 1) ? true : false);
					n=(n - r) / 2
				}
				this.trial.unshift((n === 1) ? true : false);
				for (var i = this.trial.length; i < this.responses.length; i++) this.trial.unshift(false);
			}
			this.checkResult = function() {
				eex.setSubmited();
				for (var i = 0; i < this.possibillities; i++) {
					if (this.responses[i].checked !== this.trial[this.responses[i].id]) return false;
				}
				return true;
			}
			this.toHTML = function() {
				var out = "<table class='question'>";
				out+="<tr><td>" + this.question + "</td></tr>";
				if (this.image.length > 0) out+="<tr><td><img src='" + this.image + "' alt='' /></td></tr></table>";
				out+="<table class='response'><colgroup><col width=20 /><col width=* /></colgroup>";
				for (var i = 0; i < this.possibillities; i++) {
					out+="<tr><td style='width:20px'><input id='cb" + this.id + "." + i + "' type='checkbox' ";
					if (eex.mcq.released) out+="disabled ";
					else out+="onClick='javascript:eex.mcq.click(this.id.substring(2),this.checked)' ";
					if (this.responses[i].checked) out+="checked='checked' ";
					out+="/></td><td><label for='cb" + this.id + "." + i + "'>" + this.responses[i].response + "</label></td>";
					out+="</tr>";
				}
				out+="</table>";
				return out;
			}
		}
	}
}

//Prototype-Erweiterungen
Array.prototype.shuffle = function(){
	var tmp, rand;
	for(var i = 0; i < this.length - 1; i++){
		rand=Math.floor(Math.random() * this.length);
		tmp = this[i]; 
		this[i] = this[rand]; 
		this[rand] = tmp;
	}
}
Array.prototype.swap = function(p,s){
	var tmp = this[p];
	this[p] = this[s];
	this[s] = tmp;
}
String.prototype.charCode = function(){
	var a = new Array(this.length);
	for(var i = 0; i<a.length; i++){
		a[i] = "&#" + this.charCodeAt(i) + ";";
	}
	return a.join("");
}

//Hilfsfunktion zum Sortieren von Zahlen
function Numsort(a, b) {
	return a - b;
}

window.onload = function() {
	showExercise();
	var btnSave = document.getElementById("btnSave");
	btnSave.disabled=false;
	btnSave.onclick = function() {
		btnSave.disabled=true;
		if(eex.getSubmited()) return false;
		showSolution();
		var result = eex.getResult();
		eex.setSubmited();
		document.getElementsByName("exerciseTime").value = eex.elapsedTime();
		document.getElementsByName("exerciseResult").value = result;
		if (typeof jQuery !== "function") {
			alert(unescape(eex.ms.questSaveRes.replace("%result%",result)));
		} else {
			if (confirm(unescape(eex.ms.questSaveRes.replace("%result%",result) + eex.ms.questSaveQuest)) === false) return false;
			$.ajax( {
				type: 'post',
				dataType: 'json',
				data: 'action=save&' + $('#frmData').serialize(),
				url: '../ajax.php',
				success: function(result) {},
				error: function(jqXHR, textStatus, errorThrown) { alert(jqXHR.responseText); }
			});
		}
	}
}

